<script setup lang="ts">
import { onMounted, onUnmounted, ref } from 'vue'
import 'leaflet/dist/leaflet.css'
import { useMapStore } from '@/stores/map'
import L from 'leaflet'

const mapStore = useMapStore()
mapStore.popup = L.popup()
const mapContainer = ref()

function setMap() {
  mapStore.map = L.map(mapContainer.value).setView([51.505, -0.09], 2)
  mapStore.currentLayer = L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
    maxZoom: 19,
    attribution: '© <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>'
  }).addTo(mapStore.map)
}

function onLayerChange(layer: string) {
  mapStore.map.removeLayer(mapStore.currentLayer)
  if (layer === 'OpenStreetMap') {
    mapStore.currentLayer = L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
      maxZoom: 19,
      attribution: '© <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>'
    }).addTo(mapStore.map)
  } else if (layer === 'Satellite') {
    mapStore.currentLayer = L.tileLayer('http://{s}.google.com/vt/lyrs=s&x={x}&y={y}&z={z}', {
      maxZoom: 20,
      subdomains: ['mt0', 'mt1', 'mt2', 'mt3']
    }).addTo(mapStore.map)
  }
}

function getCurrentLocation() {
  navigator.geolocation.getCurrentPosition(
    (position) => {
      mapStore.currentLat = position.coords.latitude
      mapStore.currentLng = position.coords.longitude
      onCurrentLocation()
    },
    (error) => {
      console.log(error.message)
    }
  )
}

function onCurrentLocation() {
  const currentLatLng = L.latLng(mapStore.currentLat, mapStore.currentLng)
  const brandLatLng = mapStore.brandMarker.getLatLng()
  const distance = mapStore.map.distance(currentLatLng, brandLatLng)

  mapStore.checkUser = distance <= 500
  console.log('ChekGOLOCAL1 : ', mapStore.checkUser)

  mapStore.map.setView([mapStore.currentLat, mapStore.currentLng], 15)

  if (mapStore.currentMarker) {
    mapStore.map.removeLayer(mapStore.currentMarker)
  }

  mapStore.currentMarker = L.marker([mapStore.currentLat, mapStore.currentLng], {
    icon: L.icon({
      iconUrl: './img/logo/7100_7_08.jpg',
      iconSize: [30, 30]
    }),
    draggable: true
  })
    .addTo(mapStore.map)
    .bindPopup('You are here')

  mapStore.currentMarker.on('dragend', function (event: any) {
    var marker = event.target
    var position = marker.getLatLng()
    mapStore.currentLat = position.lat
    mapStore.currentLng = position.lng

    const currentLatLng = L.latLng(mapStore.currentLat, mapStore.currentLng)
    const brandLatLng = mapStore.brandMarker.getLatLng()
    const distance = mapStore.map.distance(currentLatLng, brandLatLng)
    mapStore.checkUser = distance <= 500
    console.log('ChekGOLOCAL2 : ', mapStore.checkUser)
  })
}

function onMapClick(e: any) {
  if (mapStore.useIn !== 'branchView') return
  mapStore.lat = e.latlng.lat
  mapStore.lng = e.latlng.lng
  if (mapStore.flageMarker) {
    mapStore.map.removeLayer(mapStore.flageMarker)
  }
  mapStore.flageMarker = L.marker([mapStore.lat, mapStore.lng], {
    icon: L.icon({
      iconUrl: './img/logo/flage.png',
      iconSize: [30, 30]
    })
  }).addTo(mapStore.map)
  mapStore.popup.setLatLng(e.latlng).setContent(e.latlng.toString()).openOn(mapStore.map)
}

function branchIcon(lat: number, lng: number, name: string) {
  if (mapStore.brandMarker) {
    console.log('1' + ' lat' + lat + 'long ' + lng)
    mapStore.map.removeLayer(mapStore.brandMarker)
  }
  mapStore.brandMarker = L.marker([lat, lng], {
    icon: L.icon({
      iconUrl: './img/logo/logo1 (1).png',
      iconSize: [30, 30]
    })
  })
    .addTo(mapStore.map)
    .bindPopup(name)

  const circle = L.circle([lat, lng], {
    color: 'red',
    fillColor: '#f03',
    fillOpacity: 0.5,
    radius: 500
  }).addTo(mapStore.map)
}
function view(lat: number, lng: number) {
  mapStore.map.setView([lat, lng], 19)
}

onMounted(async () => {
  setMap()
  getCurrentLocation()
  mapStore.map.on('click', onMapClick)
  if (mapStore.branchAddress != null) {
    branchIcon(mapStore.branchAddress.lat, mapStore.branchAddress.lng, mapStore.branchAddress.name)
    view(mapStore.branchAddress.lat, mapStore.branchAddress.lng)
  }
})
</script>

<template>
  <v-card height="400" width="900" v-if="mapStore.useIn === 'branchView'">
    <v-row>
      <v-col cols="12" md="6">
        <v-sheet :elevation="6" :height="400" :width="400" border rounded>
          <v-row style="padding-top: 20px" class="d-flex justify-center">
            <!-- <v-btn>
              <v-icon @Click="onCurrentLocation()"> mdi-crosshairs-gps</v-icon>
            </v-btn> -->
            <v-btn>
              <v-icon @Click="onLayerChange('OpenStreetMap')"> mdi-road </v-icon>
            </v-btn>
            <v-btn>
              <v-icon @Click="onLayerChange('Satellite')"> mdi-satellite-variant </v-icon>
            </v-btn>
          </v-row>
          <v-row class="d-flex justify-center">
            <div ref="mapContainer" style="width: 400px; height: 350px"></div>
          </v-row>
        </v-sheet>
      </v-col>
      <v-col cols="12" md="6">
        <v-sheet :elevation="6" :height="400" :width="400" border rounded>
          <v-card title="set location" variant="outlined">
            <v-row>
              <v-text-field
                v-model="mapStore.currentLat"
                label="Latitude"
                style="height: 50px; width: 150px"
              ></v-text-field>
              <v-text-field
                v-model="mapStore.currentLng"
                label="Longitude"
                style="height: 50px; width: 150px"
              ></v-text-field>
            </v-row>
            <v-row justify="center" align="center" style="padding-top: 10px; padding-bottom: 10px">
              <v-btn @Click="onCurrentLocation()">Set</v-btn>
            </v-row>
          </v-card>
          <v-card title="Current location" variant="outlined" @click="onCurrentLocation()">
            <v-card-text style="padding-left: 25px">
              <v-row> Latitude: {{ mapStore.currentLat }} </v-row>
              <v-row> Longitude: {{ mapStore.currentLng }} </v-row>
            </v-card-text>
          </v-card>
          <v-card
            title="Flage location"
            variant="outlined"
            @Click="view(mapStore.lat, mapStore.lng)"
          >
            <v-card-text style="padding-left: 25px">
              <v-row> Latitude: {{ mapStore.lat }} </v-row>
              <v-row> Longitude: {{ mapStore.lng }} </v-row>
            </v-card-text>
          </v-card>
          <v-card
            v-if="mapStore.branchAddress != null"
            title="Branch location"
            variant="outlined"
            @click="view(mapStore.branchAddress.lat, mapStore.branchAddress.lng)"
          >
            <v-card-text style="padding-left: 25px">
              <v-row> Latitude: {{ mapStore.branchAddress.lat }} </v-row>
              <v-row> Longitude: {{ mapStore.branchAddress.lng }} </v-row>
            </v-card-text>
          </v-card>
        </v-sheet>
      </v-col>
    </v-row>
  </v-card>
  <v-card height="400" width="400" v-if="mapStore.useIn === 'checkUser'">
    <v-row>
      <v-col cols="12" md="6">
        <v-sheet :elevation="6" :height="400" :width="400" border rounded>
          <v-row style="padding-top: 20px" class="d-flex justify-center">
            <!-- <v-btn>
              <v-icon @Click="onCurrentLocation()"> mdi-crosshairs-gps</v-icon>
            </v-btn> -->
            <v-btn>
              <v-icon @Click="onLayerChange('OpenStreetMap')"> mdi-road </v-icon>
            </v-btn>
            <v-btn>
              <v-icon @Click="onLayerChange('Satellite')"> mdi-satellite-variant </v-icon>
            </v-btn>
          </v-row>
          <v-row class="d-flex justify-center">
            <div ref="mapContainer" style="width: 400px; height: 350px"></div>
          </v-row>
        </v-sheet>
      </v-col>
    </v-row>
  </v-card>
</template>
